%!octave 
%      
%       
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.28 2014/02/06 16:17:43 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=kohonen(X,W,k),
   szX = size(X,1) ;
   szC = k^2 ;

   % инициализируем структуру кластеров	
   C={};C(szC+1)=0;
   
   for i=1:szX,
	  % входной вектор номер i
	  xi = X(i,:) ;
	  % растояния от xi до всех векторов весов W
	  R=dist_points(W,xi) ;
	  % номер im выхода с минимальным расстоянием до входа xi 
	  [ v ic ] = min(R) ;

	  vc = C{ic} ; C{ic}=[ vc i ] ;
   endfor
   C(end)=[];

   % собираем номера пустых кластеров
   iz=[];
   for i=1:szC,
	  if size(C{i},2)<1, iz=[iz i]; endif ;
   endfor
   % удаляем пустые кластеры
   C(iz)=[];

   retval= C;

endfunction

