%!octave 
%      
%       
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.28 2014/02/06 16:17:43 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=kohonen_training(X,k,s,max_iter),
   szX = size(X,1) ;
   n = size(X,2) ;

   % случайная начальная матрица весов
   W = rand(k^2,n)-0.5 ; 
   save("-ascii","result/w0.txt","W");

   for t=1:max_iter,
	  W0=W;

      sp=0.99;
	  % случайная последовательность индексов от 1 до szX 
	  ii=randperm(szX);
	  for i=ii,
		 % входной вектор номер i
		 xi = X(i,:) ;

		 % растояния от xi до всех векторов весов W
		 R=dist_points(W,xi) ;

		 % номер im выхода с минимальным расстоянием до входа xi 
		 [ vm im ] = min(R) ;

		 % рассчитать вектор функции окрестности для точки im 
		 nb=nbh(im,k,t) ;

		 % корректируем матрицу весов
		 dW= (W-xi).* nb ;
		 W-= dW * sp ;
		 sp*=s;
	  endfor

	  dw=sum(sum(W-W0));

	  printf("%i/%i : %f     \r",t,max_iter,dw);

% 	  C0=kohonen(X,W0,k) ;
% 	  C=kohonen(X,W,k) ;
% 	  if isequal(C,C0), break; endif

   endfor

   retval= W;

endfunction 


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=nbh(c,n,t),
   % преобразовать номер C в пару индексов (двумерная решетка n x n )
   i=ceil(c/n) ; 
   j=(c-(i-1)*n) ;
   c=[ i j ];
	 
   %et=1./exp(t.^(-2));
   et=t/(t+4);

   X=[]; for i=1:n, X=[ X ; (1:n)' (ones(n,1)*i) ] ; endfor
   d=sum((X-c).^2,2) ; 
   retval=exp(-d.*et) ;		 

endfunction 

