%!octave 
%      
%       
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.28 2014/02/06 16:17:43 mechanoid Exp $



% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% загрузить точки 
X = load("data/p04a/X.txt") ;


szX = size(X,1) 

% размер решётки нейронов выходного слоя (k x k)
k = 3 ;

% скорость обучения
s=0.7;

% максимальное количество итерации процедуры обучения
%MAX_ITER=szX;
MAX_ITER=100;


printf('kohonen training\n') ;
W=kohonen_training(X,k,s,MAX_ITER) ;
save("-ascii","result/w.txt","W");
%W=load("data/w.txt") ;

printf('build clusters structure\n') ;
C=kohonen(X,W,k) ;
save("-text","result/c.txt","C");

printf('build distance matrix\n') ;
R=build_dist_matrix(X) ;
printf('check quality\n') ;
q=quality_clusters(R,C) ;
save('-text','result/q.txt','q') ;

printf('plot result\n') ;
plot_clusters(X,C,q) ;
