%!octave 
%
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: plot_clusters.m,v 1.4 2014/02/06 16:29:30 mechanoid Exp mechanoid $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=plot_clusters(X,C,q),
   pix_size='-S720,720';
   pix_font_size=7;
	
   szX = size(X,1);
   szC = size(C,2);

   xm=ceil(max(max(X))) ; ax=[ 0 xm 0 xm ] ;
   
   % рисуем точки в начальном состоянии
   clf; hold on; axis(ax); grid on; set(gca,'fontsize',pix_font_size); 
   plot( X(:,1), X(:,2), '.b' ) ;
   title(sprintf('init state, points:%i',szX));
   print('result/X.png','-dpng' ,pix_size) ;

   % цветовая палитра по числу кластеров 
   palette = jet(szC) ;

   clf; hold on; axis(ax);grid on;set(gca,'fontsize',pix_font_size); 
   cc=0;
   for k=1:szC,
      printf('%i/%i    \r',k,szC);
		
	  % рисуем точки кластеров
	  ick = C{k} ; sz=size(ick,2) ;
	  if sz>0,
	     cc+=1;
		 xk = X(ick,:) ;
		 plot( xk(:,1), xk(:,2), '.', 'color', palette(k,:) ) ;

		 % рисуем оболочку кластера
		 if sz>2,
			kh = convhull(xk(:,1),xk(:,2)) ;
			plot(xk(kh,1), xk(kh,2), '-r') ;
		 else
			plot(xk(:,1), xk(:,2), '-r') ;
		 endif

	  endif

   endfor

   title(sprintf('points:%i, clusters:%i\nquality: %f',szX,cc,q));
   print('result/C.png','-dpng' ,pix_size) ;

endfunction
